#include <windows.h>
#include <tchar.h>
#include <stdio.h>


void ErrorExit(LPTSTR lpszFunction) 
{ 
    // Retrieve the system error message for the last-error code

    LPVOID lpMsgBuf;
    LPVOID lpDisplayBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );

    // Display the error message and exit the process

    lpDisplayBuf = (LPVOID)LocalAlloc(LMEM_ZEROINIT, 
        (lstrlen((LPCTSTR)lpMsgBuf) + lstrlen((LPCTSTR)lpszFunction) + 40) * sizeof(TCHAR)); 
    sprintf((LPTSTR)lpDisplayBuf, TEXT("%s failed with error %d: %s"), lpszFunction, dw, lpMsgBuf); 
    //LocalSize(lpDisplayBuf) / sizeof(TCHAR),
    printf("[] %s\n", lpDisplayBuf);
//    MessageBox(NULL, (LPCTSTR)lpDisplayBuf, TEXT("Error"), MB_OK); 

    LocalFree(lpMsgBuf);
    LocalFree(lpDisplayBuf);
    ExitProcess(dw); 
}

HWND chWin;
LRESULT CALLBACK WinProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK ChildProc(HWND, UINT, WPARAM, LPARAM);
HINSTANCE gIns;
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpcmdline, int nShowCmd) {
	WNDCLASS wndCls;
	wndCls.cbClsExtra=0;
	wndCls.cbWndExtra=0;
	wndCls.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);
	wndCls.hCursor=LoadCursor(NULL, IDC_ARROW);
	wndCls.hIcon=NULL;
	wndCls.hInstance=gIns=hInstance;
	wndCls.lpfnWndProc=WinProc;
	wndCls.lpszClassName=TEXT("windowfrompoint");
	wndCls.lpszMenuName=NULL;
	wndCls.style=CS_HREDRAW | CS_VREDRAW;
	RegisterClass(&wndCls);


	wndCls.lpszClassName=TEXT("child window");
	wndCls.hbrBackground=(HBRUSH)GetStockObject(BLACK_BRUSH);
	wndCls.lpfnWndProc=ChildProc;
	RegisterClass(&wndCls);
 
#if 0
#define RegisterDeviceNotification __MINGW_NAME_AW(RegisterDeviceNotification)
#define PostMessage __MINGW_NAME_AW(PostMessage)
#define PostThreadMessage __MINGW_NAME_AW(PostThreadMessage)
#define PostAppMessage __MINGW_NAME_AW(PostAppMessage)
#define DefWindowProc __MINGW_NAME_AW(DefWindowProc)
#define CallWindowProc __MINGW_NAME_AW(CallWindowProc)
#define RegisterClass __MINGW_NAME_AW(RegisterClass)
#define UnregisterClass __MINGW_NAME_AW(UnregisterClass)
#define GetClassInfo __MINGW_NAME_AW(GetClassInfo)
#define RegisterClassEx __MINGW_NAME_AW(RegisterClassEx)
#define GetClassInfoEx __MINGW_NAME_AW(GetClassInfoEx)
#endif


//AllocConsole();
//freopen("CONOUT$", "wt", stdout);

//HWND hChild = GetConsoleWindow();
//ShowWindow(hChild, SW_HIDE);


	HWND hwnd=CreateWindow(  TEXT("windowfrompoint"), TEXT("windowfrompoint window"), WS_OVERLAPPEDWINDOW, 100, 100, 300, 300, NULL, NULL, hInstance, NULL  );
	ShowWindow(hwnd, nShowCmd);


	MSG message;
	while(1) 
	{
		bool r = GetMessage(&message, hwnd, 0, 0);
		if( r == -1 )
		{
		}
		else
		{
			TranslateMessage(&message);
			DispatchMessage(&message);
			
			DWORD dw = GetLastError();
			if(dw == 1400)		// == ߸ â ڵԴϴ.
			{
				printf("2 dw    :  %d\n", dw);
				ErrorExit("dw");
			}
		}
		

//		printf("GetMessage\n");
//		printf("%d, %d, %d, %d\n", message.message, message.time, message.wParam, message.lParam);

		

//printf("%d, %d, %d, %d\n", message.message, message.time, message.wParam, message.lParam);
//0, -1081645485, -1628160668, 2293292
//0, 2444, 2, 1204
//1084, 2508
//2420, 3384

#if 0
	//&& message.time == 2444
	if(chWin == NULL&& message.wParam == 2)
	{
		Sleep(1);
		break;
	}
#endif

	}

	UnregisterClass("child window", hInstance);
	UnregisterClass("windowfrompoint", hInstance);


//FreeConsole();


	printf("end\n");

	return message.wParam;
}

BOOL CALLBACK EnumChildProc(HWND hwndChild, LPARAM lParam) 
{ 
	printf("EnumChildProc\n");
    LPRECT rcParent; 
    int i, idChild; 
 
    // Retrieve the child-window identifier. Use it to set the 
    // position of the child window. 
 
    idChild = GetWindowLong(hwndChild, GWL_ID); 
 
    // Size and position the child window.  
 
    rcParent = (LPRECT) lParam; 
    MoveWindow(hwndChild, 100, 100, 50, 50, TRUE); 
 
    // Make sure the child window is visible. 
 
    ShowWindow(hwndChild, SW_SHOW); 
 
    return TRUE;
}


WNDPROC wpOrigEditProc; 
RECT rcClient;
LRESULT CALLBACK WinProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam) 
{
	printf("WinProc\n");
	switch(message) 
	{
		case WM_CREATE:
			chWin=CreateWindow(TEXT("child window"), TEXT("child child"), WS_CHILD | WS_VISIBLE, 50, 50, 100, 100, hwnd, (HMENU)NULL, gIns, NULL);  
//            wpOrigEditProc = (WNDPROC) SetWindowLong(chWin, GWL_WNDPROC, (LONG) ChildProc); 
printf("WM_CREATE    : %d\n", chWin);
			break;

        case WM_SIZE:   // main window changed size 
printf("WM_SIZE\n");
            GetClientRect(hwnd, &rcClient); 
//            EnumChildWindows(hwnd, EnumChildProc, (LPARAM) &rcClient); 
            return 0; 

		case WM_MOUSEMOVE:
printf("%d %d\n", LOWORD(lparam), HIWORD(lparam));
			MoveWindow(chWin, LOWORD(lparam), HIWORD(lparam), 50, 50, TRUE);
			break;

		case WM_QUIT:
printf("WM_QUIT\n");
			break;
			
		case WM_CLOSE:
printf("WM_CLOSE\n");
			SendMessage(chWin, WM_DESTROY, 0, 0);
			DestroyWindow(chWin);
			break;
			
		case WM_NCDESTROY:
printf("WM_NCDESTROY\n");
			break;

		case WM_DESTROY:
printf("WM_DESTROY\n");

			UnregisterClass("child window", gIns);
			UnregisterClass("windowfrompoint", gIns);

			SendMessage(chWin, WM_DESTROY, 0, 0);
			DestroyWindow(chWin);
			break;
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}
 
 
 
 
LRESULT CALLBACK ChildProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam) 
{
	printf("ChildProc\n");
	switch(message) 
	{
		case WM_CREATE:
printf("Child - WM_CREATE\n");
			break;

		case WM_MOUSEMOVE:
printf("Child - %d %d\n", LOWORD(lparam), HIWORD(lparam));
//			MoveWindow(chWin, LOWORD(lparam), HIWORD(lparam), 50, 50, TRUE);
			break;

		case WM_QUIT:
printf("Child - WM_QUIT\n");
			break;

		case WM_CLOSE:
printf("Child - WM_CLOSE\n");
			PostQuitMessage(0);
			break;
			
		case WM_NCDESTROY:
printf("Child - WM_NCDESTROY\n");
			break;

		case WM_DESTROY:
printf("Child - WM_DESTROY\n");

			UnregisterClass("child window", gIns);
			UnregisterClass("windowfrompoint", gIns);

			PostQuitMessage(0);
			chWin = NULL;
			break;
	} 

	return DefWindowProc(hwnd, message, wparam, lparam);
//	return CallWindowProc(wpOrigEditProc, hwnd, message, wparam, lparam);
}



